VERSION 5.00
Object = "{0ECD9B60-23AA-11D0-B351-00A0C9055D8E}#6.0#0"; "MSHFLXGD.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   2925
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   5325
   LinkTopic       =   "Form1"
   ScaleHeight     =   2925
   ScaleWidth      =   5325
   StartUpPosition =   3  'Windows Default
   Begin MSHierarchicalFlexGridLib.MSHFlexGrid MSHFlexGrid1 
      Height          =   1455
      Left            =   120
      TabIndex        =   1
      Top             =   0
      Width           =   5055
      _ExtentX        =   8916
      _ExtentY        =   2566
      _Version        =   393216
      _NumberOfBands  =   1
      _Band(0).Cols   =   2
   End
   Begin VB.CommandButton cmdCreate 
      Caption         =   "Test"
      Height          =   795
      Left            =   1200
      TabIndex        =   0
      Top             =   1920
      Width           =   2235
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private mConn As Connection
Private mCmd As Command
Private mRs As Recordset
'
'Synposis:  Create connection, and command objects that
'           are used throughout the rest of the demostration
'
Private Sub Init(Optional ByVal bEmbedded As Boolean = False)
    Set mConn = New Connection
    If Not bEmbedded Then
        mConn.Open "Provider=FB.FirebirdProvider; Data Source=localhost; Initial Catalog=c:\TestDB2.fdb; User ID=SYSDBA; Password=masterkey" ', "SYSDBA", "masterkey"
    Else
        mConn.Open "Provider=FB.FirebirdProvider; Initial Catalog=c:\TestDB2.fdb; User ID=SYSDBA; Password=masterkey" ', "SYSDBA", "masterkey"
    End If
    Set mCmd = New Command
    mCmd.ActiveConnection = mConn
End Sub
'
'Synposis:  Delete all parameters, if any, from the command object
'
Private Sub ClearParameters()
    While mCmd.Parameters.Count > 0
        mCmd.Parameters.Delete 0
    Wend
End Sub
'
'Synposis:  run test
'
Private Sub cmdCreate_Click()
    On Error GoTo trap
    Init
    
    CreateArrayTestTable
    TestArray
    StoreProc
    CreateTable
    TestTransaction
    Exit Sub
trap:
    MsgBox Err.Description
End Sub
'
'Synposis:  If the table product does not exist, create it
'
Private Sub CreateTable()
    Set mRs = mConn.OpenSchema(adSchemaTables)
    While Not mRs.EOF
        If UCase(mRs.Fields("table_name")) = "PRODUCT" Then
            Exit Sub 'if found, do nothing but return
        End If
        mRs.MoveNext
    Wend
    ClearParameters
    'if not found, create the product table
    mCmd.CommandText = "CREATE TABLE product (id INTEGER NOT NULL PRIMARY KEY, partNumber VARCHAR(20), name VARCHAR(60))"
    Debug.Print mCmd.CommandText
    mCmd.Execute
End Sub
'
'Synposis:      Demostrate data parameter input and output
'               1. Create store procedure
'               2. Call store procedure with in/out parameters
'               3. print output
'
Private Sub StoreProc()
    On Error GoTo trap
    mCmd.CommandText = "Create PROCEDURE MyProc (In0 INTEGER, "
    mCmd.CommandText = mCmd.CommandText + " In1 SMALLINT, In2 BIGINT, In3 FLOAT, In4 DOUBLE PRECISION) "
    mCmd.CommandText = mCmd.CommandText + " RETURNS (o0 INTEGER, o1 SMALLINT, o2 BIGINT, o3 FLOAT, o4 DOUBLE PRECISION)"
    mCmd.CommandText = mCmd.CommandText + " AS BEGIN  o0=In0*10; o1=In1*2; o2=In2*2; o3=In3*3.0; o4=In4*4; END"
    Debug.Print mCmd.CommandText
    mCmd.Execute
trap:
    Dim p(5) As New Parameter
    
    p(0).Direction = adParamInputOutput
    p(0).Type = adInteger
    p(0).Value = 2
    p(1).Direction = adParamInputOutput
    p(1).Type = adSmallInt
    p(1).Value = 10000
    p(2).Direction = adParamInputOutput
    p(2).Type = adBigInt
    p(2).Value = 123444444012#
    p(3).Direction = adParamInputOutput
    p(3).Type = adSingle
    p(3).Value = 10000.12
    p(4).Direction = adParamInput
    p(4).Type = adDouble
    p(4).Value = 111122223333.111
    p(5).Direction = adParamOutput
    p(5).Type = adDouble
    p(5).Value = 0#
    mCmd.CommandText = "EXECUTE PROCEDURE MyProc(?, ?, ?, ?, ?)" 'output shall not be in this query string per firebird
    Dim n As Integer
    Debug.Print p(0).Value
    Debug.Print p(1).Value
    Debug.Print p(2).Value
    Debug.Print p(3).Value
    Debug.Print p(5).Value  'output
    mCmd.Execute n, p
    
    Debug.Print p(0).Value
    Debug.Print p(1).Value
    Debug.Print p(2).Value
    Debug.Print p(3).Value
    Debug.Print p(5).Value  'output
    
End Sub

'
'Synposis:  Create a table that has columns with data array type. If the table does not
'           exist, create it. If it does, do nothing but return
'
'           The table has the following columns:
'           ID - Integer, primary key
'           I2A - small integer, 2 dimension array
'           I4A - Integer, one dimension array with low bound 0, and upper bound 3
'           F4A - float, one dimension array with low bound 1, and upper bound 4
'           F8A - double, one dimension array with low bound 1, and upper bound 4
'           DA  - date, one dimension array with low bound 1, and upper bound 4
'           TA  - Time, one dimension array with low bound 1, and 4 as its upper bound
'           TS  - Timestamp,one dimension array with low bound 1, and 4 as its upper bound
'
'           string array is not supported in this release.
'
Private Sub CreateArrayTestTable()
    Set mRs = mConn.OpenSchema(adSchemaTables)
    While Not mRs.EOF
        If UCase(mRs("table_name").Value) = "ARRAYTEST" Then Exit Sub 'if it exists, do nothing but return
        mRs.MoveNext
    Wend
    mCmd.CommandText = "CREATE TABLE ARRAYTEST "
    mCmd.CommandText = mCmd.CommandText + "(ID INTEGER NOT NULL PRIMARY KEY, "
    mCmd.CommandText = mCmd.CommandText + "I2A SMALLINT [2,2], I4A INTEGER [0:3], "
    mCmd.CommandText = mCmd.CommandText + "F4A FLOAT [4], F8A DOUBLE PRECISION [4], "
    mCmd.CommandText = mCmd.CommandText + "DA DATE [4], TA TIME [4], TS TIMESTAMP [4])"
    mCmd.Execute
End Sub

'
'Synposis:  Demostrate data array manipulation
'           1. Delete all data from ARRAYTEST table
'           2. Store array data into ARRAYTEST table
'           3. Read data array back
'
Private Sub TestArray()
    mCmd.CommandText = "DELETE FROM ARRAYTEST"
    mCmd.Execute    'delete all records if any

    mCmd.CommandText = "INSERT INTO ARRAYTEST values (?,?,?,?,?,?,?, ?)"
    Dim I As Integer
    Dim i2a(3) As Integer   'you may use a 2 dimension matrix
                            'as long as # of elements match that
                            'declared in the table
    Dim i4a(3) As Long
    Dim f4a(3) As Single
    Dim f8a(3) As Double
    Dim da(3) As Date
    Dim ta(3) As Date
    Dim ts(3) As Date
    Dim v As Variant
    
    For I = 0 To 3
        i2a(I) = (I + 1) * (I + 1)
        i4a(I) = (I + 5) * 5
    Next I
    For I = 0 To 3
        f4a(I) = 3.141569 + I
        f8a(I) = 6.29 + I
    Next I
    For I = 0 To 3
        da(I) = DateAdd("d", I * 2, "10/09/2005")
        ta(I) = DateAdd("n", I * 5, "12:30:00")
        ts(I) = DateAdd("h", I, "10/09/2005 12:30:00")
    Next I
    Dim ps(7) As New Parameter
    ps(0).Direction = adParamInput
    ps(0).Type = adInteger
    ps(0).Value = 2
    
    ps(1).Direction = adParamInput
    ps(1).Type = adVariant
    v = i2a
    ps(1).Value = v   'short
    
    ps(2).Direction = adParamInput
    ps(2).Type = adVariant
    v = i4a
    ps(2).Value = v   'long
    
    ps(3).Direction = adParamInput
    ps(3).Type = adVariant
    v = f4a
    ps(3).Value = v   'float
    
    ps(4).Direction = adParamInput
    ps(4).Type = adVariant
    v = f8a
    ps(4).Value = f8a   'double
    
    ps(5).Direction = adParamInput
    ps(5).Type = adVariant
    v = da              'date
    ps(5).Value = v
    
    ps(6).Direction = adParamInput
    ps(6).Type = adVariant
    v = ta              'time
    ps(6).Value = v
    
    ps(7).Direction = adParamInput
    ps(7).Type = adVariant
    v = ts              'timestamp
    ps(7).Value = v

    
    For I = 0 To 7
        mCmd.Parameters.Append ps(I)
    Next I
    mCmd.Execute
    
    mCmd.CommandText = "select ID, I2A, I4A, F4A, F8A, DA, TA, TS from arraytest"
    ClearParameters
    Set mRs = mCmd.Execute
    Debug.Print mRs(0) 'please watch window to view the result
End Sub
'
'Synposis:  Test firebird transaction.
'           To prepare for the test, delete all records from the table if any
'           Insert 50 records into product table
'           Update the first record and rollback the transaction
'           Update the second record and commit the transaction
'
Private Sub TestTransaction()
    Dim ps(1) As New Parameter
    Dim I As Integer
    ClearParameters     'remove all parameters if any
    mCmd.CommandText = "delete from product"
    mCmd.Execute        'delete all records from product table
    Dim rs As Recordset
    
    'start transaction
    mConn.BeginTrans
    ps(0).Direction = adParamInput
    ps(0).Type = adInteger
    ps(1).Direction = adParamInput
    ps(1).Type = adBSTR
    mCmd.Parameters.Append ps(0)
    mCmd.Parameters.Append ps(1)
    
    'In this release, all strings saved into database are treated as unicode strings.
    'the only way to save unicode string into firebird database is to insert/update a
    'string value via an input parameter
    mCmd.CommandText = "INSERT INTO PRODUCT (ID, partNumber) VALUES (?, ?)"
    For I = 1 To 2000
        ps(0).Value = I
        ps(1).Value = "Part " & I
        Set rs = mCmd.Execute
        Set rs = Nothing
    Next I
    mConn.CommitTrans
    mCmd.CommandText = "UPDATE PRODUCT SET name=? WHERE ID = ?"
    ClearParameters
    Set ps(0) = New Parameter
    Set ps(1) = New Parameter
    ps(1).Direction = adParamInput
    ps(1).Type = adInteger
    ps(1).Value = 1
    ps(0).Direction = adParamInput
    ps(0).Type = adBSTR
    ps(0).Value = "Firebird provider"
    
    mConn.BeginTrans
    mCmd.Execute I, ps
    mConn.RollbackTrans
    ps(1).Value = 2
    mConn.BeginTrans
    mCmd.Execute I, ps
    mConn.CommitTrans
    
    ClearParameters
    mCmd.CommandText = "Select * from product"
    Set mRs = mCmd.Execute
    
    Me.MSHFlexGrid1 = 100
    Me.MSHFlexGrid1.Clear
    Set Me.MSHFlexGrid1.Recordset = mRs
End Sub

